/****************************************************************************
 *
 *  bheap.c : Хʥҡ׽
 *
 *  Programmed by Shuji Nakamura  Time-stamp: <2001-02-14>
 *
 ***************************************************************************/


#include "mymalloc.h"
#include "bheap.h"


/* ҡ׺
 * n : ǿ
 * h : ҡ׹¤ΤؤΥݥ */
void
create_bheap (int n, BHEAP * h)
{
  h->n = n;
  h->ne = 0;
  h->nfo = (int *) my_malloc (n * sizeof (int));
  h->ofn = (int *) my_malloc (n * sizeof (int));
  h->key = (double *) my_malloc (n * sizeof (double));
}


/* ҡ׽
 * h : ҡ׹¤ΤؤΥݥ */
void
init_bheap (BHEAP * h)
{
  h->ne = 0;
}


/* ҡ׳
 * h : ҡ׹¤ΤؤΥݥ */
void
free_bheap (BHEAP * h)
{
  my_free (h->nfo, h->n);
  my_free (h->ofn, h->n);
  my_free (h->key, h->n);
}


/*  key ֹ֤
 * h : ҡ׹¤ΤؤΥݥ */
int
find_max_bheap (BHEAP * h)
{
  return h->nfo[0];
}


/* Ǹ
 * i, j : 򴹤ǤΥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
swap (int i, int j, BHEAP * h)
{
  int t;

  t = h->nfo[i], h->nfo[i] = h->nfo[j], h->nfo[j] = t;
  h->ofn[h->nfo[i]] = i;
  h->ofn[h->nfo[j]] = j;
}


/* ˸äƥҡ׾
 * i : Ϥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
down_heap (int i, BHEAP * h)
{
  int j;

  while (i * 2 + 1 < h->ne)
    {
      j = i * 2 + 1;
      if (j + 1 < h->ne && h->key[h->nfo[j]] < h->key[h->nfo[j + 1]])
	j++;
      if (h->key[h->nfo[i]] >= h->key[h->nfo[j]])
	break;
      swap (i, j, h);
      i = j;
    }
}


/* ˸äƥҡ׾
 * i : Ϥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
up_heap (int i, BHEAP * h)
{
  int j;

  while (i > 0)
    {
      j = (i - 1) / 2;
      if (h->key[h->nfo[i]] <= h->key[h->nfo[j]])
	break;
      swap (i, j, h);
      i = j;
    }
}


/* ֹ i Ǥҡפ
 * i : ֹ
 * key : 
 * h : ҡ׹¤ΤؤΥݥ */
void
insert_bheap (int i, double key, BHEAP * h)
{
  h->nfo[h->ne] = i;
  h->ofn[i] = h->ne;
  h->key[i] = key;
  up_heap (h->ne, h);
  h->ne++;
}


/*  key 
 * h : ҡ׹¤ΤؤΥݥ */
void
delete_max_bheap (BHEAP * h)
{
  /*  */
  h->ne--;
  swap (0, h->ne, h);

  /* ҡ׾ */
  down_heap (0, h);
}


/* ֹ i  key  d ä
 * i : ֹ
 * d : ä
 * h : ҡ׹¤ΤؤΥݥ */
void
increase_key_bheap (int i, double d, BHEAP * h)
{
  /*  */
  h->key[i] += d;

  /* ҡ׾ */
  up_heap (h->ofn[i], h);
}
