/****************************************************************************
 *
 *  dheap.c : d ҡ׽
 *
 *  Programmed by Shuji Nakamura  Time-stamp: <2001-05-27>
 *
 ***************************************************************************/


#include "mymalloc.h"
#include "dheap.h"


/* ҡ׺
 * n : ǿ
 * d : Ҥο
 * h : ҡ׹¤ΤؤΥݥ */
void
create_dheap (int n, int d, DHEAP * h)
{
  h->n = n;
  h->d = d;
  h->ne = 0;
  h->nfo = (int *) my_malloc (n * sizeof (int));
  h->ofn = (int *) my_malloc (n * sizeof (int));
  h->key = (double *) my_malloc (n * sizeof (double));
}


/* ҡ׽
 * h : ҡ׹¤ΤؤΥݥ */
void
init_dheap (DHEAP * h)
{
  h->ne = 0;
}


/* ҡ׳
 * h : ҡ׹¤ΤؤΥݥ */
void
free_dheap (DHEAP * h)
{
  my_free (h->nfo, h->n);
  my_free (h->ofn, h->n);
  my_free (h->key, h->n);
}


/*  key ֹ֤
 * h : ҡ׹¤ΤؤΥݥ */
int
find_max_dheap (DHEAP * h)
{
  return h->nfo[0];
}


/* Ǹ
 * i, j : 򴹤ǤΥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
swap (int i, int j, DHEAP * h)
{
  int t;

  t = h->nfo[i], h->nfo[i] = h->nfo[j], h->nfo[j] = t;
  h->ofn[h->nfo[i]] = i;
  h->ofn[h->nfo[j]] = j;
}


/* ˸äƥҡ׾
 * i : Ϥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
down_heap (int i, DHEAP * h)
{
  int j, k, max;

  while (i * h->d + 1 < h->ne)
    {
      max = i * h->d + 1;
      for (k = 1, j = max + 1; k < h->d && j < h->ne; j++, k++)
        {
          if (h->key[h->nfo[j]] > h->key[h->nfo[max]])
            max = j;
        }
      if (h->key[h->nfo[i]] >= h->key[h->nfo[max]])
        break;
      swap (i, max, h);
      i = max;
    }
}


/* ˸äƥҡ׾
 * i : Ϥҡ׾ΰ
 * h : ҡ׹¤ΤؤΥݥ */
static void
up_heap (int i, DHEAP * h)
{
  int j;

  while (i > 0)
    {
      j = (i - 1) / h->d;
      if (h->key[h->nfo[i]] <= h->key[h->nfo[j]])
        break;
      swap (i, j, h);
      i = j;
    }
}


/* ֹ i Ǥҡפ
 * i : ֹ
 * key : 
 * h : ҡ׹¤ΤؤΥݥ */
void
insert_dheap (int i, double key, DHEAP * h)
{
  h->nfo[h->ne] = i;
  h->ofn[i] = h->ne;
  h->key[i] = key;
  up_heap (h->ne, h);
  h->ne++;
}


/*  key 
 * h : ҡ׹¤ΤؤΥݥ */
void
delete_max_dheap (DHEAP * h)
{
  /*  */
  h->ne--;
  swap (0, h->ne, h);

  /* ҡ׾ */
  down_heap (0, h);
}


/* ֹ i  key  d ä
 * i : ֹ
 * d : ä
 * h : ҡ׹¤ΤؤΥݥ */
void
increase_key_dheap (int i, double d, DHEAP * h)
{
  /*  */
  h->key[i] += d;

  /* ҡ׾ */
  up_heap (h->ofn[i], h);
}
