/****************************************************************************
 *
 *  graph.h : ս
 *
 *  Programmed by Shuji Nakamura  Time-stamp: <2001-07-11>
 *
 ***************************************************************************/


#ifndef NIL
#define NIL -1
#endif


/* ޹¤ */
typedef struct edge
{
  int node;		/* ³ */
  double weight;	/* Ť */
  struct edge *prev;	/*  */
  struct edge *next;	/*  */
}
EDGE;

/* չ¤ */
typedef struct graph
{
  int n;		/*  */
  int m;		/* ޿ */
  EDGE **adjlist;	/* ܥꥹ (޹¤ΤؤΥݥ󥿤) */
}
GRAPH;

/* եդѻ޹¤ */
typedef struct edge_f
{
  int node;		/* ³ */
  double weight;	/* Ť */
  struct edge_f *prev;	/*  */
  struct edge_f *next;	/*  */
  double flow;		/* ե */
}
EDGE_F;

/* եդչ¤ */
typedef struct graph_f
{
  int n;		/*  */
  EDGE_F **adjlist;	/* ܥꥹ (޹¤ΤؤΥݥ󥿤) */
  double *flow;
}
GRAPH_F;

/* ǽդѻ޹¤ */
typedef struct edge_c
{
  int node;		/* ³ */
  double weight;	/* Ť */
  struct edge_c *prev;	/*  */
  struct edge_c *next;	/*  */
  struct edge_c *reverse;	/* ոޥ */
}
EDGE_C;

/*  (EXISTING:¸ߤƤ, DELETED:줿) */
enum node_state
{
  EXISTING = 0, DELETED = 1
};

/* ǽդչ¤ */
typedef struct graph_c
{
  int n;		/*  */
  int ne;		/* ¸ߤ */
  EDGE_C **adjlist;	/* ܥꥹ (޹¤ΤؤΥݥ󥿤) */
  int *state;		/* ξ */
  double *wbuf;		/* ѥХåե */
  int *next, *prev;	/* ꥹ */
  int ehead;		/* ¸ꥹȤƬֹ */
  int dhead;		/* ꥹȤƬֹ */
}
GRAPH_C;

/* ǽդͭѻ޹¤ */
typedef struct edge_d
{
  int node;		/* ³ */
  double weight;	/* Ť */
  struct edge_d *prev;	/*  */
  struct edge_d *next;	/*  */
  struct edge_d *pair;	/* ոޥ */
}
EDGE_D;

/* ǽդͭչ¤ */
typedef struct graph_d
{
  int n;		/*  */
  int ne;		/* ¸ߤ */
  EDGE_D **adjlist;	/* Фޤܥꥹ */
  EDGE_D **revlist;	/* ޤܥꥹ */
  double *wbuf;		/* ѥХåե */
}
GRAPH_D;


void create_graph (int n, GRAPH * g);
void init_graph (GRAPH * g);
void free_graph (GRAPH * g);
void insert_edge (int v1, int v2, double w, GRAPH * g);
void input_graph (GRAPH * g);
void print_graph (GRAPH * g);

void create_graph_f (int n, GRAPH_F * g);
void init_graph_f (GRAPH_F * g);
void free_graph_f (GRAPH_F * g);
void delete_node_f (int v, GRAPH_F * g);
void insert_directed_edge_f (int s, int t, double w, GRAPH_F * g);
void print_graph_f (GRAPH_F * g);

void create_graph_c (int n, GRAPH_C * g);
void init_graph_c (GRAPH_C * g);
void free_graph_c (GRAPH_C * g);
void insert_edge_c (int v1, int v2, double w, GRAPH_C * g);
void delete_edge_c (int v, EDGE_C * e, GRAPH_C * g);
void delete_node_c (int v, GRAPH_C * g);
void restore_node_c (int v, GRAPH_C * g);
void move_node_c (int s, int t, GRAPH_C * g);
void contract_node_c (int s, int t, GRAPH_C * g);
void contract_nodes_ir_c (int nn, int nbuf[], int t, GRAPH_C * g);
void contract_nodes_c (int nn, int nbuf[], int t, GRAPH_C * g, GRAPH_C * gt);
void uncontract_nodes_c (int t, GRAPH_C * g, GRAPH_C * gt);
double get_cut_size_c (int v, GRAPH_C * g);
void simplification_c (GRAPH_C * g);
void print_graph_c (GRAPH_C * g);

void create_graph_d (int n, GRAPH_D * g);
void init_graph_d (GRAPH_D * g);
void init_subgraph_d (int nn, int nbuf[], GRAPH_D * g);
void free_graph_d (GRAPH_D * g);
void insert_directed_edge_d (int s, int t, double w, GRAPH_D * g);
void insert_edge_d (int v1, int v2, double w, GRAPH_D * g);
void delete_node_d (int v, GRAPH_D * g);
void contract_nodes_d (int nn, int nbuf[], GRAPH_D * g);
double get_cut_size_d (int v, GRAPH_D * g);
void print_graph_d (GRAPH_D * g);
