/****************************************************************************
 *
 *  mygetopt.c : GNU C Library  getopt ߴؿ
 *
 *  Programmed by Shuji Nakamura  Time-stamp: <2001-03-05>
 *
 ****************************************************************************/


#include <stdio.h>	/* NULL, stderr, fprintf() */
#include <string.h>	/* strchr() */
#include "mygetopt.h"


char *optarg = NULL;
int optind = 1;
int opterr = 1;
int optopt = '?';


static int non_opt_pos = 1;
static int chr_pos = 1;


/* ץʸ󤫤ɤȽ */
int
is_opt_str (char *s)
{
  return s[0] == '-' && s[1] != '\0';
}


/* c Υץ
 * : -1 ¸ߤʤץ,
 *          0 ɬפʤץ,
 *          1 Ȥ륪ץ, 
 *          2 ϤȤäƤȤʤƤ褤ץ */
int
get_opt_type (int c, char *optstr)
{
  char *p;

  if (c == ':')
    return -1;
  p = strchr (optstr, c);
  if (p == NULL)
    return -1;
  if (p[1] != ':')
    return 0;
  if (p[2] != ':')
    return 1;
  return 2;
}


/* ץ򥹥饤ɤ */
void
slide_opt (char *argv[])
{
  char *t;
  int i;

  t = argv[optind];
  for (i = optind; i > non_opt_pos; i--)
    argv[i] = argv[i - 1];
  argv[non_opt_pos] = t;
  non_opt_pos++;
}


/* ޥɥ饤󥪥ץ᤹ */
int
my_getopt (int argc, char *argv[], char *optstr)
{
  int c;

  /* ץ󸡺 */
  for (;; optind++)
    {
      /* ʾ̵нλ */
      if (optind >= argc)
	{
	  optind = non_opt_pos;
	  return -1;
	}
      /* "--" ʤ饹饤ɤƽλ */
      if (strcmp (argv[optind], "--") == 0)
	{
	  slide_opt (argv);
	  optind = non_opt_pos;
	  return -1;
	}
      if (is_opt_str (argv[optind]))
	break;
    }

  optopt = '?';
  optarg = NULL;
  c = argv[optind][chr_pos];
  switch (get_opt_type (c, optstr))
    {
    case -1:		/* ¸ߤʤץ󤬤ä */
      if (opterr)
	fprintf (stderr, "%s: illegal option -- %c\n", argv[0], c);
      optopt = c;
      c = '?';
      chr_pos++;
      if (argv[optind][chr_pos] == '\0')
	{
	  slide_opt (argv);
	  optind++, chr_pos = 1;
	}
      break;

    case 0:		/* ɬפʤץξ */
      chr_pos++;
      if (argv[optind][chr_pos] == '\0')
	{
	  slide_opt (argv);
	  optind++, chr_pos = 1;
	}
      break;

    case 1:		/* ɬפʥץξ */
      chr_pos++;

      /* Ʊȡ˰ä */
      if (argv[optind][chr_pos] != '\0')
	{
	  optarg = &argv[optind][chr_pos];
	  slide_opt (argv);
	  optind++, chr_pos = 1;
	  break;
	}

      slide_opt (argv);
      optind++;

      /* Υȡ˰ */
      if (optind < argc)
	{
	  optarg = argv[optind];
	  slide_opt (argv);
	  optind++, chr_pos = 1;
	  break;
	}

      /* Ĥʤ */
      if (opterr)
	fprintf (stderr, "%s: option requires an argument -- %c\n", argv[0],
		 c);
      chr_pos = 1;
      optopt = c;
      c = '?';
      break;

    case 2:		/* ϤȤäƤȤʤƤ⤤ץξ */
      chr_pos++;
      if (argv[optind][chr_pos] != '\0')
	optarg = &argv[optind][chr_pos];
      slide_opt (argv);
      optind++, chr_pos = 1;
      break;
    }

  return c;
}


#if 0
int
main (int argc, char **argv)
{
  int i, c;

  printf ("options\n");
  while ((c = my_getopt (argc, argv, "ab:cd:")) != EOF)
    {
      switch (c)
	{
	case 'a':
	case 'c':
	  printf ("-%c,optind:%d\n", c, optind);
	  break;
	case 'b':
	case 'd':
	  printf ("-%c,optind:%d,optarg:%s\n", c, optind, optarg);
	  break;
	case '?':
	  printf ("-%c,optind:%d,optopt:%c\n", c, optind, optopt);
	  break;
	}
    }
  printf ("\nnon-options\n");
  for (; optind < argc; optind++)
    printf ("%s\n", argv[optind]);
  printf ("\narg\n");
  for (i = 0; i < argc; i++)
    printf ("%s ", argv[i]);
  printf ("\n");
  return 0;
}
#endif
