/****************************************************************************
 *
 *  mymalloc.c : my_malloc/my_calloc/my_free ؿ
 *
 *  Programmed by Shuji Nakamura  Time-stamp: <2001-02-16>
 *
 ***************************************************************************/


#include <stdlib.h>	/* NULL, malloc(), calloc(), free() */
#include "error.h"
#include "mymalloc.h"


size_t cur_alloc_size = 0;
size_t max_alloc_size = 0;


void *
my_malloc (size_t size)
{
  void *ptr;

  ptr = malloc (size);
  if (ptr == NULL)
    error ("out of memory (used %d kbyte)", cur_alloc_size/1024);
  cur_alloc_size += size;
  if (cur_alloc_size > max_alloc_size)
    max_alloc_size = cur_alloc_size;
  return ptr;
}


void *
my_calloc (size_t n, size_t size)
{
  void *ptr;

  ptr = calloc (n, size);
  if (ptr == NULL)
    error ("out of memory (used %d kbyte)", cur_alloc_size/1024);
  cur_alloc_size += n * size;
  if (cur_alloc_size > max_alloc_size)
    max_alloc_size = cur_alloc_size;
  return ptr;
}


void
my_free_main (void *ptr, size_t size)
{
  free (ptr);
  cur_alloc_size -= size;
}
